#include <stdio.h>
#include <stdlib.h>

#include "Counting.h"
#include "Radix.h"
#include "Bucket.h"
//#define ARRAY_SIZE 10
#define ARRAY_SIZE 40

int main(int argc, char *argv[])
{
    int sortingAlgorithmIndex;
	//int array[ARRAY_SIZE] = {5, 8, 1, 2, 7, 3, 6, 9, 4, 10};
    int array[ARRAY_SIZE] = {5, 23, 40, 18, 29, 560, 342, 534, 213, 8,
                            1, 2, 7, 3, 6, 9, 4, 10, 745, 452, 784,
                            13, 56, 87, 94, 34, 276, 74, 96, 71, 85,
                            73, 76, 89, 24, 62, 24, 78, 83, 254};
	for(int i = 0; i < ARRAY_SIZE; i++)
	{
		printf("%d ", array[i]);
	}
	printf("\nQual sort usar?\n1 - Counting Sort\n");
    printf("2 - Radix Sort\n3 - Bucket Sort\n");
    scanf("%d", &sortingAlgorithmIndex);
    switch(sortingAlgorithmIndex)
    {
        case 1:
            countSort(array, ARRAY_SIZE);
            break;
        case 2:
            radixSort(array, ARRAY_SIZE);
            break;
        case 3:
            bucketSort(array, ARRAY_SIZE);
            break;
        default:
            printf("Invalid Sorting Option!\n");
            exit(EXIT_FAILURE);
    }

	for(int i = 0; i < ARRAY_SIZE; i++)
	{
		printf("%d ", array[i]);
	}
    printf("\n");
	return 0;
}
